<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Namespace: b_1_4_thermdata_client</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Namespace: b_1_4_thermdata_client</h1>

    




<section>

<header>
    
        <h2>
            <span class="ancestors"><a href="b_create_caldata_buttons_client.b_1_dataviz.html">.b_1_dataviz</a>.</span>b_1_4_thermdata_client</h2>
        
    
</header>

<article>
    <div class="container-overview">
    
        
            <div class="description"><p>call argument : postgresData - all data needed for the algebraic engine model</p>
<h4>Overview callback and surrounding html</h4>
This namespace describes the callback function body of client sided
thermdata event. The callback creates 4 different types of selection fields
implemented as push buttons as described in the list below. 
The push buttons for the engine characterizing data are implemented
as push buttons with a connected callback which gets activated by
clicking on the button. The other 3 types of buttons are activating
views by sending post requests to the server. The server reacts by
redirecting the request to the correct destination according to 
the 'ActiveView' state of this function selection view.
<br>
The lists shows the 4 execution steps of this view
<br>
<li>create activation button for graphical editors by an input form <a href="tutorial-webclients.html#post_reqs_graph">: graphical view : HTML elements</a></li>
<li>create activation button for simulation view by an input form <a href="tutorial-webclients.html#post_reqs_signals">: simulation view : HTML elements</a></li>
<li>create activation button for static code analysis view by an input form <a href="tutorial-webclients.html#post_reqs_staticA">: static code view : HTML elements</a></li>
<li>create push buttons for thermodynamic engine data (find the explanation of the subfunctions executed during the button creation in the links)
   <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html"><code>1. get all already existing button names</code></a>
   <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html#.forAllObjectinPostgresDataset"><code>2. iterate across all data items and create a push button per item if it does not yet exist</code></a> 
      <br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="module-d_handleModelData_client.html"><code>2.1 add data handler, process data on mouse click</code></a>
<br>
<br>
</li>
<h4>Local editor</h4>
In addition to the graphical editing views there is a simple table editor for quick editing available in this function selection view. This
editor is mainly for editing constants but may also be used if no graphical 3d or 2d information is necessary. 
<li>create activation button for static code analysis view by an input form <a href="tutorial-webclients.html#post_reqs_table">:empty table HTML elements</a></li>
<br>
<h4>Concept of this callback function</h4>
This function creates push buttons for each data element in the postgres
dataset. The dataset is coded in JSON. There are expected data elements in that
dataset. Usually all data is sent during send/receive event. It may happen
that the send/receive event gets interrupted and the dataset is sent multiple
times. In such a case only a subset of buttons is generated during an early
transmission. During later transmissions the data is sent again but already
existing buttons must no be created again. 
<br>
program steps : 
<li>copy json data to buffer 'obj'</li>
<li>retrieve all class names of existing buttons : <a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html"><code>getter function for button names</code></a></li>
<li>create push buttons for data elements where there is not already a corresponding button</li>
<li>connect mouse click handler to the pushbutton and use the classname of the pushbutton as a call argument</li>
<br>
Result : each data element gets an own push button. Only the first transmission of a data element gets recognized. 
Further transmissions get ignored. A handler specific to the button/data element gets called as the push button
gets pushed. 
<br>
mouse click event : <a href="data.d_1_handler.html"><code>data.d_1_handler</code></a></div>
        

        


<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_createDataViz.js.html">Script/createDataViz.js</a>, <a href="Script_createDataViz.js.html#line248">line 248</a>
    </li></ul></dd>
    

    

    

    
</dl>


        
    
    </div>

    

    

    

    

    

    

    
        <h3 class="subsection-title">Members</h3>

        
            
<h4 class="name" id=".names_vec"><span class="type-signature">(static) </span>names_vec<span class="type-signature"> :Array.&lt;string></span></h4>




<div class="description">
    <p>Connect</p>
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">Array.&lt;string></span>


        </li>
    </ul>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_createDataViz.js.html">Script/createDataViz.js</a>, <a href="Script_createDataViz.js.html#line320">line 320</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id=".obj"><span class="type-signature">(static) </span>obj<span class="type-signature"> :object</span></h4>




<div class="description">
    <p>postgres data in json format for all parameters of the
algrebraic theremodynamic engine model</p>
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">object</span>


        </li>
    </ul>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_createDataViz.js.html">Script/createDataViz.js</a>, <a href="Script_createDataViz.js.html#line310">line 310</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    
    <h4 class="name" id=".forAllObjectinPostgresDataset"><span class="type-signature">(static) </span>forAllObjectinPostgresDataset<span class="signature">(obj)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>if a key value of the postgres data is not yet used as a button name, a
button is created and named after the key value. A handler which is activated
on a mouse click it is attached to the button. The handler receives the postgres data
set as an argument.</p>
<br>
variables : 
<li>k - key name of data element (local to the loop)</li>
<li>names_vec - array of class names of push buttons (created out of the existing push buttons)</li>
<br>
if no push button class name is equal to the key name of the data object in the current loop revolution
a new push button is created by a switch case expression. Each case comes with a specific text for the 
button, a specific assignment to the html 'div' element which is identified by its classname and a
handler with a specific call argument. 
<br><br>
Upper level div elements:
<li>engine</li>
<li>compressor</li>
<li>turbine</li>
<li>exhaust</li>
<li>emissions</li>
<li>roadloads</li>
<br>
key names of data elements:
<li>EngineConstants</li>
<li>EngineAmbientConditions</li>
<li>EngineEta</li>
<li>EngineFriction</li>
<li>EngineVolumEff</li>
<li>EngineCompr</li>
<li>EngineFullLoadData</li>
<li>EngineTurbine</li>
<li>EngineExhaustParam</li>
<li>EngineRawParticulates</li>
<li>EngineRawNox</li>
<li>EngineRoadLoads</li>
<br>
<a href="module-d_handleModelData_client.html"><code>mouse click event handler</code></a>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>obj</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array.&lt;object></span>


            
            </td>

            

            

            <td class="description last"><p>array of objects</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_createDataViz.js.html">Script/createDataViz.js</a>, <a href="Script_createDataViz.js.html#line322">line 322</a>
    </li></ul></dd>
    

    

    

    
</dl>




















        
            

    

    
    <h4 class="name" id=".handleDataset"><span class="type-signature">(static) </span>handleDataset<span class="signature">(postgresData, EngineAmbientConditions, socket)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>as long as there is no push button clicked, the
'Engine Ambient Condition Data' is selected and prepared for
further processing by calling the push button handler.</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>postgresData</code></td>
            

            <td class="type">
            
                
<span class="param-type">object</span>


            
            </td>

            

            

            <td class="description last"><p>dataset received from postgres</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>EngineAmbientConditions</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>default call parameter</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>socket</code></td>
            

            <td class="type">
            
                
<span class="param-type">object</span>


            
            </td>

            

            

            <td class="description last"><p>socketIO connection to request server action</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="Script_createDataViz.js.html">Script/createDataViz.js</a>, <a href="Script_createDataViz.js.html#line419">line 419</a>
    </li></ul></dd>
    

    

    
    <dt class="tag-see">See:</dt>
    <dd class="tag-see">
        <ul>
            <li><p><a href="module-d_handleModelData_client.html"><code>mouse click event handler</code></a></p></li>
        </ul>
    </dd>
    

    
</dl>




















        
    

    

    
</article>

</section>




</div>

<nav>
    <h2><a href="index.html">Connected Controls Web App Docu</a></h2><h3>Modules</h3><ul><li><a href="module-a_index_server.html">a_index_server</a></li><li><a href="module-b_create_caldata_buttons_client.html">b_create_caldata_buttons_client</a></li><li><a href="module-c_socketCom_server.html">c_socketCom_server</a></li><li><a href="module-d_handleModelData_client.html">d_handleModelData_client</a></li><li><a href="module-e_getModelStimulationData_server.html">e_getModelStimulationData_server</a></li><li><a href="module-f_getPostgresData_server.html">f_getPostgresData_server</a></li><li><a href="module-g_setPostgresData_server.html">g_setPostgresData_server</a></li><li><a href="module-h_deletePostgresData_server.html">h_deletePostgresData_server</a></li><li><a href="module-i_getPostgresWOsocket_server.html">i_getPostgresWOsocket_server</a></li><li><a href="module-j_updatePostgresData_server.html">j_updatePostgresData_server</a></li><li><a href="module-k_select-stimulation_client.html">k_select-stimulation_client</a></li><li><a href="module-l_3d_map_visualization_client.html">l_3d_map_visualization_client</a></li><li><a href="module-m_curveGraphGenerator_client.html">m_curveGraphGenerator_client</a></li><li><a href="module-n_create_simulation_view_client.html">n_create_simulation_view_client</a></li><li><a href="module-o_3d_map_visualization_initialization_client.html">o_3d_map_visualization_initialization_client</a></li><li><a href="module-p_3d_map_table_generator.html">p_3d_map_table_generator</a></li></ul><h3>Namespaces</h3><ul><li><a href="audio.k_1_startStimulation.html">k_1_startStimulation</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html">b_1_dataviz</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames.html">b_1_1_getClassNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html">b_1_3_getAllButtonNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html">b_1_4_thermdata_client</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html">c_1_socketfunction</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">c_1_1_socketConnected</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData.html">c_1_1_1_initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata.html">c_1_1_2_tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata.html">c_1_1_3_curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable.html">c_1_1_4_getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve.html">c_1_1_5_getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData.html">c_1_1_6_getStimData</a></li><li><a href="data.d_1_handler.html">d_1_handler</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html">m_1_curveGraphGenerator</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html">n_1_create_simulation_view</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html">n_1_1_rcvAudioFilePaths</a></li></ul><h3>Classes</h3><ul><li><a href="d3.html">d3</a></li><li><a href="express.html">express</a></li><li><a href="pool.html">pool</a></li><li><a href="response.html">response</a></li><li><a href="router.html">router</a></li><li><a href="selection.html">selection</a></li><li><a href="server.html">server</a></li><li><a href="socket.html">socket</a></li></ul><h3>Events</h3><ul><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html#.event:thermdata">thermdata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:curvedata">curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:disconnect">disconnect</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getCurve">getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getTable">getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:initNewData">initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:tabledata">tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:time">time</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html#.event:connection">connection</a></li><li><a href="data.d_1_handler.html#.event:curvedata">curvedata</a></li><li><a href="data.d_1_handler.html#.event:initNewData">initNewData</a></li><li><a href="data.d_1_handler.html#.event:tabledata">tabledata</a></li><li><a href="module-e_getModelStimulationData_server.html#~event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:getCurve">getCurve</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:sendCurve">sendCurve</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:periodic_time">periodic_time</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html#.event:click_stimFileSelector">click_stimFileSelector</a></li></ul><h3>Tutorials</h3><ul><li><a href="tutorial-codeAnalysisAndRefactoring.html">Static source code analysis and refactoring interface</a></li><li><a href="tutorial-conceptUnitTest.html">conceptUnitTest</a></li><li><a href="tutorial-graphicalEditor.html">Graphical editor for maps and curves</a></li><li><a href="tutorial-modelStimulation.html">Stimulation of physical and engine control models</a></li><li><a href="tutorial-staticEngineModel.html">Static combustion engine model</a></li><li><a href="tutorial-webclients.html">webclients</a></li></ul><h3>Global</h3><ul><li><a href="global.html#buildNav">buildNav</a></li><li><a href="global.html#publish">publish</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Fri Sep 17 2021 09:09:23 GMT+0200 (Mitteleuropäische Sommerzeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>